/////////////////////////////////////////////////////////////////////////////////
/////////////////////////////////////////////////////////////////////////////////
// Company       : 人о·Ƽ޹˾
//                 http://xiaomeige.taobao.com
// Web           : http://www.corecourse.cn
// 
// Create Date   : 2021/07/04 00:00:00
// Module Name   : ADC128S102_UDP_RGMII
// Description   : ADC128S102_UDP_RGMIIݲɼ̫ϵͳ
// 
// Dependencies  : 
// 
// Revision:
// Revision 0.01 - File Created
// Additional Comments:
// 
/////////////////////////////////////////////////////////////////////////////////
`timescale 1ns / 1ps
module ADC128S102_UDP_RGMII(
	 Clk,
	 reset_n,
     
    eth_rxc,
	 eth_rxd,
	 eth_rxdv,

	 ADC_SCLK,
	 ADC_DOUT,
	 ADC_DIN,
	 ADC_CS_N,	
	
	 eth_gtxc,
	 eth_txd,
	 eth_txen,
	 eth_rst_n,
	 eth_mdc,
	 eth_mdio
	 );

    //eth receive interface
	 input eth_rxc; //̫ʱ
	 input [3:0] eth_rxd; //̫
	 input eth_rxdv; //̫Ч־
	 
	 //eth send interface
	 output eth_gtxc; //̫ʱ
	 output [3:0] eth_txd; //̫
	 output eth_txen; //̫Ч־
	 
	 // mdio
	 output eth_rst_n; //̫λЧ
	 inout eth_mdc;
	 inout eth_mdio;
	
	 input Clk;
    input reset_n;

	 output ADC_SCLK;	//ADC ݽӿʱź
	 output ADC_CS_N;  //ADC ݽӿʹź
	 input  ADC_DOUT;		//ADCתADCFPGA
	 output ADC_DIN;	//ADCźFPGAָͨADC
	   
    wire clk125m_o; 
  
    wire [7:0]ChannelSel;
    wire [15:0]DataNum;
    wire [31:0]ADC_Speed_Set;   
    wire RestartReq;
    
    wire [7:0]adc_data_flag;
    wire [15:0]adc_data_mult_ch;
    wire fifowrreq;
    wire [15:0]fifowrdata_in;
	wire clk_64M;
	 
    reg RestartReq_d0,RestartReq_d1;
	reg [31:0]Number_d0,Number_d1;
	 
    parameter local_mac = 48'h00_0a_35_01_fe_c0;
    parameter local_ip = 32'hc0_a8_00_02;
    parameter local_port = 16'd5000;
    assign eth_rst_n = 1;

    wire rst_n;
    assign rst_n = ~reset_n;

// 		ģ 
//	ad_datacnt ad_datacnt_0(
//		.clk50m(Clk),
//		.reset_n(reset_n),
		
//		.RestartReq(RestartReq),
//		.DataNum(DataNum),
		
//		.adc_data_flag(adc_data_flag),
//		.adc_data_mult_ch(adc_data_mult_ch)
//		);


  pll instance_name
   (
    // Clock out ports
    .clk_out1(clk_64M),     // output clk_out1
   // Clock in ports
    .clk_in1(Clk)); 
	 
    eth_receive_cmd#(
        .local_mac  (local_mac),
        .local_ip   (local_ip),
        .local_port (local_port)
    )eth_receive_cmd
    (
       .rgmii_rx_clk_i(eth_rxc),
       .clk(clk_64M),
       .reset(rst_n),
       .rgmii_rxd(eth_rxd),
       .rgmii_rxdv(eth_rxdv),
       
       .clk125m_o(clk125m_o),
       .ChannelSel(ChannelSel),
       .DataNum(DataNum),
       .ADC_Speed_Set(ADC_Speed_Set),
       .RestartReq(RestartReq)
    );

	  eth_send_data#(
        .dst_mac(48'hFF_FF_FF_FF_FF_FF),
        .src_mac(48'h00_0a_35_01_fe_c0),
        .dst_ip(32'hc0_a8_00_03),
        .src_ip(32'hc0_a8_00_02),
        .dst_port(16'd6102),
        .src_port(16'd5000)
    )eth_send_data(
       .reset(rst_n),
       .clk(clk_64M),
       .clk125m_o(clk125m_o),
       .eth_fifo_wrdata(fifowrdata_in),
       .eth_fifo_wrreq(fifowrreq),
       .RestartReq_0_d1(RestartReq_d1),
       .Number_d1(Number_d1),
       
       .rgmii_tx_clk(eth_gtxc),
       .rgmii_txd(eth_txd),
       .rgmii_txen(eth_txen)
    );
      
	
	wire [11:0]adc128_data;
	
	
	adc128s102_1msps adc128s102_1msps(
		.Clk(clk_64M),
		.Rst_n(reset_n),
		
		.adc_data_flag(adc_data_flag),
//        .adc_data_flag(),   //
		.Data(adc128_data),
		
		.En_Conv(1'b1),
		.ADC_State(),
		.DIV_PARAM(8'd2),
		
		.ADC_SCLK(ADC_SCLK),
		.ADC_DOUT(ADC_DOUT),
		.ADC_DIN(ADC_DIN),
		.ADC_CS_N(ADC_CS_N)
	);
	
	assign adc_data_mult_ch = {4'd0,adc128_data};//ʱע

    adc_write_ctrl adc_write_ctrl (
        .Clk(clk_64M),
        .Reset_n(reset_n),
        .DataNum(DataNum),
        .RestartReq(RestartReq),
        .ChannelSel({ChannelSel[6:0],ChannelSel[7]}),
        .adc_data_flag(adc_data_flag),
        .adc_data_mult_ch(adc_data_mult_ch),
    
        .fifowrreq(fifowrreq),
        .fifowrdata(fifowrdata_in)
    );      

	always@(posedge clk125m_o)
	begin
		Number_d0 <= DataNum;
		Number_d1 <= Number_d0;
		
		RestartReq_d0 <= RestartReq;
		RestartReq_d1 <= RestartReq_d0;
	end  

endmodule