//	  
module ad_datacnt(
	clk50m,
	reset_n,
	
	RestartReq,
	DataNum,
	
	adc_data_flag,
	adc_data_mult_ch
	);
	
	input	clk50m;
	input	reset_n;
	input	RestartReq;
	input	[14:0]DataNum;
	
	output	[7:0]adc_data_flag;
	output	[15:0]adc_data_mult_ch;
	
	reg [7:0]adc_data_flag;
	reg [15:0] adc_data_mult_ch;
	reg [3:0]state;
	reg [15:0]rwdata_cnt;
	always@(posedge clk50m or negedge reset_n)
		if(!reset_n)begin
			rwdata_cnt <= 15'd0;
			adc_data_flag <=1'b0;
			adc_data_mult_ch <= 16'd0;
			state <= 4'd0;
		end
		else begin
			case(state)
				0:
				if(RestartReq)begin
						state <= 4'd1;
		
				end
				else
						state = 0;
				1:
					if(rwdata_cnt==DataNum)begin
						rwdata_cnt <= rwdata_cnt;
						adc_data_flag <= 1'b0;
						adc_data_mult_ch <= 16'd0;
						state <= 4'd2;
				end
				else begin
						adc_data_mult_ch <= rwdata_cnt;
						rwdata_cnt <= rwdata_cnt +  1'b1;
						adc_data_flag <=1'b1;   
				end 
				2:
				begin
					rwdata_cnt <= 15'd0;
					state <= 4'd0; 
				end
				default:state <= 4'd0;
			endcase
	end
endmodule
